﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Controls.Menus;
using Infragistics.DragDrop;

namespace XamDataTreeDataSet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.xamDataTree1.DataContext = GenerateData().Tables["Parent"].DefaultView;
            this.xamDataTree2.DataContext = GenerateData().Tables["Parent"].DefaultView;
        }

        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
            data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");
            
            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("Name", typeof(string));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("ID", typeof(int));
            children.Columns.Add("Child", typeof(string));
            children.Columns.Add("Age", typeof(int));
            children.Columns.Add("Parent_ID", typeof(int));

            children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[3], false);

            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, "Parent" + i });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] { j, "Child" + j, j + i, i });
                }
            }

            data.AcceptChanges();

            return data;
        }

        private void xamDataTree_NodeDragDrop(object sender, Infragistics.Controls.Menus.TreeDropEventArgs e)
        {
            if (e.DragDropEventArgs.OperationType == OperationType.Copy)
            {
                XamDataTreeNode dropNode = (e.DragDropEventArgs.DropTarget as XamDataTreeNodeControl).Node;
                DataRowView dragData = (e.DragDropEventArgs.DragSource as XamDataTreeNodeControl).Node.Data as DataRowView;

                if ((dropNode.Data as DataRowView).Row.Table.TableName == dragData.Row.Table.TableName)
                {
                    if ((dropNode.Data as DataRowView).Row.GetParentRow("Parent_Child") == null)
                    {
                        (dropNode.Data as DataRowView).Row.Table.Rows.Add(new object[]{
                        dragData.Row.ItemArray[0],
                        dragData.Row.ItemArray[1],});
                    }
                    else
                    {
                        (dropNode.Data as DataRowView).Row.Table.Rows.Add(new object[]{
                        dragData.Row.ItemArray[0],
                        dragData.Row.ItemArray[1],
                        dragData.Row.ItemArray[2],
                        (dropNode.Data as DataRowView).Row.GetParentRow("Parent_Child").ItemArray[0]});
                    }
                }
            }

        }
    }
}
